Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 436986 - app-portage/g-cpan - perl-gcpan/Finance-QuoteHist-1.16 attempts to pull in perl-gcpan/Date-Manip, ignoring stock dev-perl/DateManip
Summary: app-portage/g-cpan - perl-gcpan/Finance-QuoteHist-1.16 attempts to pull in pe...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Robin Johnson
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-10-02 16:59 UTC by Paul McDermott
Modified: 2016-05-12 10:22 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Paul McDermott 2012-10-02 16:59:48 UTC
Installing perl-gcpan/Finance-QuoteHist is dependant on the Perl CPAN module Date::Manip. This is provided by perl-gcpan/Date-Manip, but is also provided by the stock dev-perl/DateManip.

Finance-QuoteHist prefers the former, although the later is already installed.

perl-gcpan/Date-Manip can't be installed alongside dev-perl.DateManip because of file clashes (they are the same module, after all)

Reproducible: Always

Steps to Reproduce:
1.emerge -avD Finance-QuoteHist
2.
3.
Actual Results:  
These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N     ] dev-perl/regexp-common-2011121001.0.0  0 kB
[ebuild  N     ] dev-perl/Test-Inter-1.30.0  USE="-test" 0 kB
[ebuild  N     ] perl-gcpan/Date-Manip-6.34::x-portage  0 kB
[ebuild  N     ] dev-perl/HTML-Element-Extended-1.180.0  0 kB
[ebuild  N     ] dev-perl/HTML-TableExtract-2.110.0  0 kB
[ebuild  N     ] perl-gcpan/Finance-QuoteHist-1.16::x-portage  0 kB

Total: 6 packages (6 new), Size of downloads: 0 kB

Would you like to merge these packages? [Yes/No] 


Expected Results:  
perl-gcpan/Finance-QuoteHist chooses the stock dev-perl/QuoteHist instead

perl-gcpan/Date-Manip used to be installed. I removed it to allow dev-perl/DateManip to install following an upgrade, which then created a problem for perl-gcpan/Finance-QuoteHist

I can see that the naming of dev-perl/DateManip is different from the usualy standard for perl modules, which may be part of the problem.

Not sure whether this is a gcpan issue, of an issue with the dev-perl.DateManip ebuild, or the auto-generate perl-gpcan/Finance-QuoteHist ebuild
Comment 1 Paul McDermott 2012-10-02 17:00:20 UTC
[5001:/mnt/hda2/home/paul/Desktop]$ emerge --info
Portage 2.1.11.9 (default/linux/x86/10.0/desktop/gnome, gcc-4.5.4, glibc-2.15-r2, 3.2.12-gentoo i686)
=================================================================
System uname: Linux-3.2.12-gentoo-i686-Intel-R-_Core-TM-_i7_CPU_950_@_3.07GHz-with-gentoo-2.1
Timestamp of tree: Tue, 02 Oct 2012 01:45:01 +0000
ccache version 3.1.7 [enabled]
app-shells/bash:          4.2_p37
dev-java/java-config:     2.1.11-r3
dev-lang/python:          2.7.3-r2, 3.2.3
dev-util/ccache:          3.1.7
dev-util/cmake:           2.8.7-r5
dev-util/pkgconfig:       0.27.1
sys-apps/baselayout:      2.1-r1
sys-apps/openrc:          0.9.8.4
sys-apps/sandbox:         2.5
sys-devel/autoconf:       2.13, 2.68
sys-devel/automake:       1.10.3, 1.11.6
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.5.4
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4-r1
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 3.1 (virtual/os-headers)
sys-libs/glibc:           2.15-r2
Repositories: gentoo x-portage
ACCEPT_KEYWORDS="x86"
ACCEPT_LICENSE="* -@EULA dlj-1.1 Oracle-BCLA-JavaSE AdobeFlash-10.3"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O2 -march=native -pipe"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /usr/share/maven-bin-2.2/conf /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.3/ext-active/ /etc/php/cgi-php5.3/ext-active/ /etc/php/cli-php5.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -march=native -pipe"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -march=i686 -pipe"
FEATURES="assume-digests binpkg-logs ccache config-protect-if-modified distlocks ebuild-locks fixlafiles news parallel-fetch parse-eapi-ebuild-head protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
FFLAGS="-O2 -march=i686 -pipe"
GENTOO_MIRRORS="http://mirror.bih.net.ba/gentoo/ http://128.61.111.9/pub/gentoo rsync://212.219.56.133/www.ibiblio.org/gentoo/ ftp://gentoo.imj.fr/pub/gentoo/"
LANG="en_GB.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="en_GB en"
MAKEOPTS="-j9"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage"
SYNC="rsync://rsync.europe.gentoo.org/gentoo-portage"
USE="X a52 aac acl acpi alsa bash-completion bluetooth branding bzip2 bzlib cairo cdda cdr cli colord consolekit cracklib crypt ctype cups cxx dba dbus dovecot-sasl dri dts dvd dvdr eds emboss encode evo exif fam firefox flac fortran gif gnome gnome-keyring gnome-online-accounts gpm gstreamer gtk iconv imap java5 jpeg lcms libnotify libwww logrotate mad maildir mmx mng modules mp3 mp4 mpeg mudflap mysql nautilus ncurses nls nptl ogg opengl openmp pam pango pcre pdf png policykit ppds pppd pulseaudio qt3support qt4 readline sasl scanner sdl session socialweb spell ssl startup-notification svg syslog tcpd threads tiff truetype udev udisks unicode upower usb userlocales vim vim-syntax vorbis wxwidgets x264 x86 xcb xml xmlrpc xv xvid zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1 emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en_GB en" PHP_TARGETS="php5-3" PYTHON_TARGETS="python3_2 python2_7" RUBY_TARGETS="ruby18 ruby19" SANE_BACKENDS="hp" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 2 Paul McDermott 2012-10-02 17:09:49 UTC
My (old) perl-gcpan/Finance-QuoteHist ebuilds contained references to perl-gcpan/Date-Manip. I deleted the entire Finance-QuoteHist directory from /usr/local/portage and then tried to re-install Finance::QuoteHist using g-cpan:

g-cpan -i Finance::QuoteHist

This created a new ebuild no-longer reliant on perl-gpcan/Date-Manip, which then installed. So this appears to be a suitable work around.

I would say there is still and issue with references to out of date g-cpan ebuilds when a system ebuild comes along to replace g-cpan ebuild. Perhaps this should be handled by g-cpan?
Comment 3 DIZ 2013-09-01 08:54:01 UTC
I'm having a similar issue. g-cpan creates ebuilds, and then goes to calculate dependencies, and if something newly created conflicts with an existing tree ebuild in dev-perl, it complains that there is a problem with ambiguous ebuild names.

At this point I've been emerging the dev-perl requested module, and then going back to the g-cpan command, and eventually it all comes together. But this is a bit tedious....

Ideally it seems at this point that g-cpan might disambiguate by asking whether the dev-perl module is indeed desired.

Just a suggestion! Otherwise g-cpan is amazing.
Comment 4 Kent Fredric (IRC: kent\n) gentoo-dev 2016-03-10 10:52:48 UTC
I'm hoping my pkgmove of dev-perl/DateManip to its correct name, dev-perl/Date-Manip will make this problem go away: 

https://github.com/kentfredric/gentoo/commits/kentnl/fix-DateManip-names

But you won't be able to test it until dilfridge cherry-picks the branch.

It doesn't fix the underlying problem where gcpan is not smart enough to resolve this on its own, but hopefully, fixing the package that causes the issue will at least give you some reprieve ... after .... the 4 years you've been waiting.

If any of you are git savvy and can confirm that this migration avoids bumping into this gcpan bug, that'd be awesome =).
Comment 5 Kent Fredric (IRC: kent\n) gentoo-dev 2016-03-11 20:12:59 UTC
DateManip now renamed to Date-Manip in tree. HTH.
Comment 6 Sergiy Borodych 2016-05-12 07:42:15 UTC
Do you have issue with new g-cpan 0.16.7 still?
Comment 7 Sergiy Borodych 2016-05-12 09:15:17 UTC
At the moment (0.16.7):

 * Ebuild already exists for Date-Manip (dev-perl/Date-Manip)

Seem like no bug here now.